# ESPleaf

## Layout description

Layout is defined in `LAYOUT` in `config.h`.

LEDs within a node are supposed to be installed counter-clockwise. The edge where the cables enter the node is node 0. To its right (counter-clockwise, remember) is corner 0. Then edge 1, corner 1, edge 2, corner 2 before coming back to edge 0.

Thereby, the next panel can either be installed along edge 1 or edge 2. (But the cable has to go corner 0, corner 1, corner 2 first.)

First panel is ignored in `LAYOUT`. First entry in `LAYOUT` is the edge through which the cable leaves Node 0 to Node 1 - which can be either Edge 1 or Edge 2.

On the next panel, the edge the cable is coming through is called Edge 0 again. And so on.

So, `LAYOUT` countains a list of edges the cable takes to leave to the next node.

## Commands

Command can be sent via MQTT to `MQTT_TOPIC_COMMANDS`. Syntax is `key=value` or `key=value&key2=value2...`.

Valid keys are:
* `mode` sets a new mode. Valid modes are:
  * `corners`
  * `nodes`
  * `first_corner`
  * `first_node`
  * `flash`
  * `static`
  * `off`
* `brightness` sets the overall brightness of the lamp. Values are from 0 to 255 inclusive.
* `duration` if sets, `mode` and `brightness` are set for this amount of seconds only.
* `color` sets the color for `static` and `flash` modes. A predefined color name is expected.
* `speedup` sets a speedup for faster animations. Default value 1, possible values are 1 to 255. 0 will lead to an exception.

## Startup sequence

During startup:
* 1 green corner: FastLED is initialized.
* 2 green corners: WiFi is connecting...
* 3 green corners: Layout is analyzed...
* 4 green corners: Connecting to MQTT server...
* 5 green corners (only if OTA_DELAY is set): Waiting for an OTA connection...
* Everything green (quarter of a second): Initialization done.