#include "syslog.h"
#include "config.h"

#ifdef SYSLOG_HOST
	static uint16_t syslog_msg_id = 1;

	void syslog(String msg, uint8_t severity) {
		uint8_t facility = 16; // local0
		if (severity > 7) severity = 7;
		WiFiUDP udp;

		udp.beginPacket(SYSLOG_HOST, SYSLOG_PORT);
		udp.write("<");
		udp.write(String(facility * 8 + severity).c_str());
		udp.write(">1 - " OTA_HOSTNAME " core 1 ");
		udp.write(String(syslog_msg_id++).c_str());
		udp.write(" - ");
		udp.write(msg.c_str());
		udp.endPacket();
	}
#endif